-- Priority List 3
-- by Jadya
-- EU-Well of Eternity

-- tab 2

local addonName, addonTable = ...
local L = addonTable.L
local AddColor = addonTable.AddColor

local addon = PriorityList
local wishlist = addon.WishListFunctions
local chars = addon.CharFunctions
local menus = addon.MenuFunctions
local items = addon.ItemFunctions

local dd_char

local function onShow()
 dd_char:SetParent(PLTabFrame2)
 dd_char:Show()
 PLListbox:Show()
end

local function onHide()

end

local function updateListButton(self, data)
 if not data then return end

 self.t = "item"
 local name, _, quality, _, _, _, _, _, equipSlot, texture = items:GetItemInfo(data.itemID)
 if data.personal then
  self.background:SetVertexColor(0.2,1,0.6,0.1)
 else
  self.background:SetVertexColor(0.2,0.6,1,0.1)
 end
 if not name then
  self.lefticon:SetTexture("Interface\\ICONS\\Ability_Mage_TimeWarp")
  self.s_topleft:SetText(AddColor(L["receiving_item_info"], "GOLD"))
  self.s_bottomleft:SetText("")
  self.s_topright:SetText("")
  self.s_bottomright:SetText("")
 else
  self.link = data.link
  local bns = items:GetBonusString(items:ExtractBonuses(data.link))
  self.s_topright:SetText((AddColor(L["looted"]..(bns ~= "" and " -"..bns or ""), "LIGHT_BLUE") or ""))
  self.lefticon:SetTexture(texture)
  local _,_,_,c = GetItemQualityColor(quality)
  self.s_topleft:SetText((c and ("|c"..c) or "")..name.."|r")
  self.s_bottomleft:SetText("")
  --self.s_bottomleft:SetText(AddColor(data.time and date(nil, tonumber(data.time)) or "<unknown date>", "GRAY"))
  self.s_bottomright:SetText("")
 end
 return true
end

local sorted_table = {}
function addon.listboxUpdate2(self)
 local offset  = HybridScrollFrame_GetOffset(self)
 local buttons = self.buttons
 local height  = 30

 local list = PLWish_List[addon.sel_char] and PLWish_List[addon.sel_char][addon.sel_difficulty].looted

 if not list then
  self:HideButtons()
  return
 end

 wipe(sorted_table)
 for k,v in pairs(list) do
  sorted_table[#sorted_table + 1] = { link = v.link, time = tonumber(v.time), itemID = k, personal = v.personal }
 end
 table.sort(sorted_table, function(a,b) return a.time < b.time end)

 for i = 1,#buttons do
  local index = offset + i
  if index <= #sorted_table and updateListButton(buttons[i], sorted_table[index]) then
   buttons[i]:Show()
  else
   buttons[i]:Hide()
  end
 end

 HybridScrollFrame_Update(self, height * #sorted_table, height)
end

function addon.eventPulse2(event, ...)

end

function addon.createTab2()
 local f = CreateFrame("Frame", "PLTabFrame2", PLMainframe)
 f:SetPoint("TOPLEFT", PLMainframe, "TOPLEFT", 20, -100)
 f:SetScript("OnShow", onShow)
 f:SetScript("OnHide", onHide)

 -- characters dropdown
 dd_char = PLDDCharacters -- tab1 creation
 
 PLTabFrame2:Hide()
end